<!-- tab ข้อมูลส่วนบุคคล -->
<template>
  <Information
    :prefixOptions="prefixOptions"
    :genderOptions="genderOptions"
    :bloodOptions="bloodOptions"
    :statusOptions="statusOptions"
    :religionOptions="religionOptions"
    :provinceOptions="provinceOptions"
    v-model:statusEdit="statusEdit"
    :notiNoEdit="notiNoEdit"
    :step="step"
  />
  <Address v-model:statusEdit="statusEdit" :notiNoEdit="notiNoEdit" :step="step" />
  <Family
    :prefixOptions="prefixOptions"
    v-model:statusEdit="statusEdit"
    :notiNoEdit="notiNoEdit"
    :step="step"
  />
  <Occupation v-model:statusEdit="statusEdit" :notiNoEdit="notiNoEdit" :step="step" />
</template>
<script setup lang="ts">
import { ref, onMounted, watch } from 'vue'
import type { DataOption } from '@/modules/01_exam/interface/index/Main'
import Information from '@/modules/01_exam/components/Form/Profile/Information.vue'
import Address from '@/modules/01_exam/components/Form/Profile/Address.vue'
import Family from '@/modules/01_exam/components/Form/Profile/Family.vue'
import Occupation from '@/modules/01_exam/components/Form/Profile/Occupation.vue'
import http from '@/plugins/http'
import config from '@/app.config'
import { useQuasar } from 'quasar'
import { useCounterMixin } from '@/stores/mixin'

const props = defineProps({
  loader: {
    //หน้า main มีการอัพเดทค่าให้ refresh data
    type: Boolean,
    required: true
  },
  statusEdit: {
    type: Boolean,
    required: true
  },
  step: {
    type: Number,
    required: true
  }
})

const $q = useQuasar()
const mixin = useCounterMixin() //เรียกฟังก์ชันกลาง
const { modalError } = mixin
const loader = ref<boolean>(true)
const statusEdit = ref<boolean>(false)
const prefixOptions = ref<DataOption[]>([])
const bloodOptions = ref<DataOption[]>([])
const genderOptions = ref<DataOption[]>([])
const statusOptions = ref<DataOption[]>([])
const religionOptions = ref<DataOption[]>([])
const provinceOptions = ref<DataOption[]>([])

const emit = defineEmits(['update:loader', 'update:statusEdit'])

watch(statusEdit, (count: boolean, prevCount: boolean) => {
  emit('update:statusEdit', count)
})

const notiNoEdit = () => {
  modalError($q, 'ไม่สามารถไม่สามารถแก้ไขข้อมูลได้', 'มีข้อมูลที่ยังไม่ถูกบันทึกข้อมูล')
}
</script>
